<?php

/*

Plugin Name: WP-SphinnIt
Version: 1.0.1
Plugin URI: http://blog.michellemacphearson.com
Description: Adds SphinnIt button to your WordPress blog posts.
Usage: Three ways to configure

    Basic : By choosing the options under the options menu
    Intermediate: By calling the show_sphinnit() method in the theme tempalate inside the LOOP.
    Advanced: By inserting <!--sphinnit--> in any part of the post where you want the SphinnIt button to appear.

Author: Michelle MacPhearson
Author URI: http://blog.michellemacphearson.com
*/

$message = "";

if (!function_exists('smsphin_request_handler')) {
    function smsphin_request_handler() {
        global $message;

        if ($_POST['smsphin_action'] == "update options") {
            $smsphin_align_v = $_POST['smsphin_align_sl'];

    		if(get_option("smsphin_box_align")) {
    			update_option("smsphin_box_align", $smsphin_align_v);
    		} else {
    			add_option("smsphin_box_align", $smsphin_align_v);
    		}

            $message = '<br clear="all" /> <div id="message" class="updated fade"><p><strong>Option saved. </strong></p></div>';
        }
    }
}

if(!function_exists('smsphin_add_menu')) {
    function smsphin_add_menu () {
        add_options_page("SphinnIt Options", "SphinnIt Options", 8, basename(__FILE__), "smsphin_displayOptions");
    }
}

if (!function_exists('smsphin_displayOptions')) {
    function smsphin_displayOptions() {

        global $message;
        echo $message;

		print('<div class="wrap">');
		print('<h2>SphinnIt Options</h2>');

        print ('<form name="smsphin_form" action="'. get_bloginfo("wpurl") . '/wp-admin/options-general.php?page=wp-sphinnit.php' .'" method="post">');
?>

		<p>Align:
        <select name="smsphin_align_sl" id="smsphin_align_sl">
			<option value="Top Left"   <?php if (get_option("smsphin_box_align") == "Top Left") echo " selected"; ?> >Top Left</option>
			<option value="Top Right"   <?php if (get_option("smsphin_box_align") == "Top Right") echo " selected"; ?> >Top Right</option>
			<option value="Bottom Left"  <?php if (get_option("smsphin_box_align") == "Bottom Left") echo " selected"; ?> >Bottom Left</option>
			<option value="Bottom Right"  <?php if (get_option("smsphin_box_align") == "Bottom Right") echo " selected"; ?> >Bottom Right</option>
			<option value="None"  <?php if (get_option("smsphin_box_align") == "None") echo " selected"; ?> >None</option>
		</select><br /><br /> </p>

<?php
		print ('<p><input type="submit" value="Save &raquo;"></p>');
		print ('<input type="hidden" name="smsphin_action" value="update options" />');
		print('</form></div>');

    }
}


if (!function_exists('smsphin_sphinnithtml')) {
	function smsphin_sphinnithtml($float) {
		global $wp_query;
		$post = $wp_query->post;
		$permalink = get_permalink($post->ID);
        $title = urlencode($post->post_title);
		$sphinnithtml = <<<CODE

    <span style="margin: 0px 6px 0px 0px; float: $float;">

	<script type="text/javascript">
	submit_url = "$permalink";
	</script>
    <script type="text/javascript" src="http://sphinn.com/evb/button.php"></script>
	</span>
CODE;
	return  $sphinnithtml;
	}
}


if (!function_exists('smsphin_addbutton')) {
	function smsphin_addbutton($content) {

		if ( !is_feed() && !is_page() && !is_archive() && !is_search() && !is_404() ) {
    		if(! preg_match('|<!--sphinnit-->|', $content)) {
    		    $smsphin_align = get_option("smsphin_box_align");
    		    if ($smsphin_align) {
                    switch ($smsphin_align) {
                        case "Top Left":
        		              return smsphin_sphinnithtml("left").$content;
                              break;
                        case "Top Right":
        		              return smsphin_sphinnithtml("Right").$content;
                              break;
                        case "Bottom Left":
        		              return $content.smsphin_sphinnithtml("left");
                              break;
                        case "Bottom Right":
        		              return $content.smsphin_sphinnithtml("right");
                              break;
                        case "None":
        		              return $content;
                              break;
                        default:
        		              return smsphin_sphinnithtml("left").$content;
                              break;
                    }
                } else {
        		      return smsphin_sphinnithtml("left").$content;
                }

    		} else {
                  return str_replace('<!--sphinnit-->', smsphin_sphinnithtml(""), $content);
            }
        } else {
			return $content;
        }
	}
}

if (!function_exists('show_sphinnit')) {
	function show_sphinnit($float = "left") {
        global $post;
		$permalink = get_permalink($post->ID);
		echo <<<CODE

    <span style="margin: 0px 6px 0px 0px; float: $float;">

	<script type="text/javascript">
	submit_url = "$permalink";
	</script>
    <script type="text/javascript" src="http://sphinn.com/evb/button.php"></script>
	</span>
CODE;
    }
}

add_filter('the_content', 'smsphin_addbutton', 999);
add_action('admin_menu', 'smsphin_add_menu');
add_action('init', 'smsphin_request_handler');

?>
